clear 
close all
load('traiX.mat');
load('queryX.mat');
load('T.mat');

ntrai = size(trai.X,2); %ɸܿ
d = size(trai.X,1); %
nquery = length(query.label); %ƥɸܿ
nclass = max(trai.label);
imgsize = [112 92];

normalize=true; % 
svmlight.v=0;
svmlight.z='c';
svmlight.c=100;  % եȥޡΥѥ᡼
svmlight.t=0; % 0: 1:¿༰(s a*b+c)^d2:RBFexp(-gamma ||a-b||^2)3:Sigmoid
svmlight.d=1; % ¿༰d
svmlight.g=1e-2; % RBFgamma
svmlight.s=1; % ¿༰/Sigmoids
svmlight.r=1; % ¿༰/Sigmoidc
svmlight.option=sprintf('-v %d -z %c -c %f -t %d -d %d -g %f -s %f -r %f ',...
			svmlight.v, svmlight.z, svmlight.c, svmlight.t, ...
			svmlight.d, svmlight.g, svmlight.s, svmlight.r);

%%% 
if normalize 
  xnrm=sqrt(sum(trai.X.^2));
  trai.X = trai.X * diag( 1./xnrm);
  qnrm=sqrt(sum(query.X.^2));
  query.X = query.X * diag( 1./qnrm);
end

% SVMlightѤΥޥ
if find(pwd==':')~=0 % windowsξ
	svm_learn = 'svm_learn'; % svm_learn
	svm_classify = 'svm_classify'; % svm_classify
	trainfile='train.svmexample'; %ؽɸܰե
	testfile='test.svmexample'; %ƥɸܰե
	modelfile='model.svmlight'; %ǥե
	outputfile='output.svmlight'; %ϥե
else
	svm_learn = './svm_learn'; % svm_learn
	svm_classify = './svm_classify'; % svm_classify
	trainfile='./train.svmexample'; %ؽɸܰե
	testfile='./test.svmexample'; %ƥɸܰե
	modelfile='./model.svmlight'; %ǥե
	outputfile='./output.svmlight'; %ϥե
end

%% ƥɸܤSVM-lightηǽϤ
fid = fopen( testfile, 'w');
for ii=1:nquery
  fprintf(fid,'0 ');
  fprintf(fid,'%d:%e ',[ [1:d]; query.X(:,ii)' ] );
  fprintf(fid,'\n');
end
fclose(fid);

feature=zeros(nclass,nquery);
for c=1:nclass
  fprintf(2,'Class %d...',c);
  
  %% 饹cʤ1,ʳʤ-1Υ٥ȥ
  svmlabel = -1 * ones(1,ntrai);
  svmlabel( trai.label == c ) =1 ;
  
  %% SVM-lightηǥǡϤ
  fid = fopen( trainfile, 'w');
  for ii=1:ntrai
    fprintf(fid,'%d ', svmlabel(ii) );
    fprintf(fid,'%d:%e ',[ [1:d]; trai.X(:,ii)' ] );
    fprintf(fid,'\n');
  end
  fclose(fid);
  
  %% SVMγؽ
  command = sprintf('%s %s %s %s\n', svm_learn, svmlight.option, trainfile, modelfile);
  [a b]=system(command);
  
  %% Support vectorο
	fid=fopen(modelfile, 'r');
	str = fscanf( fid, '%c');
	fclose(fid);
	fprintf(2,'OK, # of SV = %d\n',sum(str==10)-11);
	clear str

  %% 
  command = sprintf('%s %s %s %s\n',svm_classify, testfile, modelfile, outputfile);
  [a b]=system(command);
  feature(c,:) = load(outputfile)';
  
end

[tmp eclass] = max(feature);
accuracy = sum(eclass(:) == query.label(:))/nquery;
fprintf('accuracy = %.2f %%\n',accuracy*100 );

%% ̤Τɽ
load('queryX.mat');
index = find( eclass(:) ~= query.label(:) );
for ii=1:min(length(index),9)
  subplot(3,3,ii);
  imagesc( reshape( T.m + T.U*query.X(:,index(ii)), imgsize(1), imgsize(2) ) );
  colormap('gray');
end
